/*
 * AbstractSelectionWizardPanel.java
 *
 * Copyright (C) 2012 Christian Mayer
 *
 * This file is part of CellXGui
 *
 */

/*
 * AbstractSelectionWizardPanel.java
 *
 * Created on Feb 14, 2012, 2:06:27 PM
 */
package cellxgui.view.dialogs.wizard;

import cellxgui.view.TextArea;
import java.beans.PropertyChangeEvent;

/**
 *
 * @author Christian Mayer <chrixian.mayer@gmail.com>
 */
abstract public class AbstractSelectionWizardPanel extends WizardPanel {

    private final TextArea textArea;

    /** Creates new form AbstractSelectionWizardPanel */
    public AbstractSelectionWizardPanel() {
        initComponents();
        errMsgLabel.setVisible(false);
        textArea = new TextArea();
        textArea.setBackground(this.getBackground());
        textArea.setWrapStyleWord(true);
        textArea.setLineWrap(true);
        jScrollPane1.setViewportView(textArea);
        jScrollPane1.setBorder(null);
        validate();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        textField = new javax.swing.JTextField();
        errMsgLabel = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();

        setMinimumSize(new java.awt.Dimension(400, 250));
        setPreferredSize(new java.awt.Dimension(400, 250));

        errMsgLabel.setForeground(new java.awt.Color(255, 0, 0));
        errMsgLabel.setText("error msg");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(31, 31, 31)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 338, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                        .addComponent(errMsgLabel)
                        .addComponent(textField, javax.swing.GroupLayout.DEFAULT_SIZE, 338, Short.MAX_VALUE)))
                .addContainerGap(31, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(32, 32, 32)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 111, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(errMsgLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(textField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(43, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel errMsgLabel;
    private javax.swing.JScrollPane jScrollPane1;
    protected javax.swing.JTextField textField;
    // End of variables declaration//GEN-END:variables

    @Override
    public void propertyChange(PropertyChangeEvent evt) {
        if (evt.getPropertyName().equals(FlatFieldModel.FILENAME_PROPERTY)) {
            textField.setText((String) evt.getNewValue());
        }
    }

    public void setText(String txt) {
        textArea.setText(txt);
    }

    public void showErrorMessage(String msg) {
        errMsgLabel.setText(msg);
        errMsgLabel.setVisible(true);
    }

    public void hideErrorMessage() {
        errMsgLabel.setVisible(false);
    }
}
